#include "classes.h"

CMemory::CMemory(UI32 u32Arg) {

	bfMemory=(BUF)new UI8[u32Arg];

	for (int i=0;i<u32Arg;i++)
		bfMemory[i]=0;

	u32LastAddress=u32Arg-1;

}

UI8 CMemory::read8(UI32 u32Arg) const {

	if (u32Arg>u32LastAddress)
		throw out_of_range("ȃAhXw");

	return ((PUI8)bfMemory)[u32Arg];

}

UI16 CMemory::read16(UI32 u32Arg) const {

	if (u32Arg>u32LastAddress-1)
		throw out_of_range("ȃAhXw");

	PUI16 pu16Tmp=(PUI16)(bfMemory+u32Arg);
	return *pu16Tmp;

}

UI32 CMemory::read32(UI32 u32Arg) const {

	if (u32Arg>u32LastAddress-3)
		throw out_of_range("ȃAhXw");

	PUI32 pu32Tmp=(PUI32)(bfMemory+u32Arg);
	return *pu32Tmp;

}

bool CMemory::write8(UI32 u32Arg,UI8 u8Arg) {

	if (u32Arg>u32LastAddress)
		throw out_of_range("ȃAhXw");

	((PUI8)bfMemory)[u32Arg]=u8Arg;

	return true;

}

bool CMemory::write16(UI32 u32Arg,UI16 u16Arg) {

	if (u32Arg>u32LastAddress-1)
		throw out_of_range("ȃAhXw");

	PUI16 pu16Tmp=(PUI16)(bfMemory+u32Arg);
	*pu16Tmp=u16Arg;

	return true;

}

bool CMemory::write32(UI32 u32Arg1,UI32 u32Arg2) {

	if (u32Arg1>u32LastAddress-3)
		throw out_of_range("ȃAhXw");

	PUI32 pu32Tmp=(PUI32)(bfMemory+u32Arg1);
	*pu32Tmp=u32Arg2;

	return true;

}

BUF CMemory::getBufferAddress(UI32 u32Arg) const{

	if (u32Arg>u32LastAddress)
		throw out_of_range("ȃAhXw");

	return bfMemory+u32Arg;

}

CMemory::~CMemory() {

	delete[] bfMemory;

}
