/*
  500000ANZXLOEz}V

            2002/ 6/30 ˁ@P
*/
#include <windows.h>
#include "win32.h"
#include <stdexcept>
using namespace std;

class CMemory { // VXeNX

public:

	CMemory(UI32);

	UI8 read8(UI32) const;
	UI16 read16(UI32) const;
	UI32 read32(UI32) const;
	BUF getBufferAddress(UI32) const;

	bool write8(UI32,UI8);
	bool write16(UI32,UI16);
	bool write32(UI32,UI32);

	~CMemory();

private:

	I32 i32MemSize;
	UI32 u32LastAddress;
	BUF bfMemory;

	bool clear();

};

class CVCPU { // zCPUC^[tF[XNX

public:

	virtual bool exec()=0;
	virtual UI32 getRegister(I32) const=0;
	virtual UI32 getPC() const=0;
	virtual UI32 getSP() const=0;
	virtual bool getSRZero() const=0;
	virtual bool getSRSig() const=0;
	virtual bool getSROF() const=0;
	virtual bool setSROF(bool)=0;
 
	virtual ~CVCPU() {}

};

class CCpu:public CVCPU { // zCPUNX

public:

	CCpu(CMemory *,UI32);

	bool reset();

	virtual bool exec() throw(logic_error);

	virtual UI32 getRegister(I32) const;
	virtual UI32 getPC() const;
	virtual UI32 getSP() const;
	virtual UI32 getSR() const;
	virtual bool getSRZero() const;
	virtual bool getSRSig() const;
	virtual bool getSROF() const;

	virtual bool setRegister(I32,UI32);
	virtual bool setPC(UI32);
	virtual bool setSP(UI32);
	virtual bool setSR(UI32);

	bool setSROF(bool);

	bool clearSR();
	bool u32OF(UI32,UI32) const;

	virtual ~CCpu();

private:

	UI32 u32Reg[16];
	UI32 GR_LAST_INDEX,REG_SP,REG_SR,REG_PC,SR_ZERO,SR_SIG,SR_OF;
	CMemory *pmMemory;

	bool exec(UI32);
	bool setSRFlag(UI32,bool);

};

class CVVIDEO {

public:

	virtual I32 getIOSize() const=0;
	virtual bool setIO(UI32)=0;
	virtual bool setVRAM(UI32,I32)=0;
	virtual bool proc()=0;

};

class CVideo:public CVVIDEO {

public:

	CVideo(CMemory *,HDC *);

	virtual I32 getIOSize() const;
	virtual bool setIO(UI32);
	virtual bool setVRAM(UI32,I32);
	virtual bool proc();

private:

	BITMAPINFO biInfo;
	HDC *lpHdc;
	I32 i32Width,i32Height,i32Bytes,i32Length,i32VRAMSize;
	UI32 u32IO,u32Pixels;
	CMemory *pmMemory;

	bool setSize(I32,I32);
	bool setBpp(I32);

};

class CVm { // z}VNX

public:

	CVm(void *);

	CVCPU * getCpu();
	CMemory * getMemory();

	bool step();

	~CVm();

private:

	CVCPU *pcpCpu;
	CMemory *pmMemory;
	CVVIDEO *pvVideo;
	void *lpScreen;

};
