#include "classes.h"

CVm::CVm(void *lpArg) {

	lpScreen=lpArg;

	pmMemory=new CMemory(128+1+128*128*4);
	pcpCpu=new CCpu(pmMemory,0);
	pvVideo=new CVideo(pmMemory,(HDC *)lpArg);

	pvVideo->setIO(128);
	pvVideo->setVRAM(128+1,128*128*4);

	pmMemory->write8(128,1);
	pvVideo->proc();

	pmMemory->write32(0x00,0x00030000);
	pmMemory->write32(0x04,129+64*4);
	pmMemory->write32(0x08,0x00010180);
	pmMemory->write32(0x0c,0x000c0000);
	pmMemory->write32(0x10,0x0000ffff);
	pmMemory->write32(0x14,0x00120000);
	pmMemory->write32(0x18,512);
	pmMemory->write32(0x1c,0x000a0101);
	pmMemory->write32(0x20,0x00900000);
	pmMemory->write32(0x24,0x0000000c);

}

CVCPU * CVm::getCpu() { return pcpCpu; }
CMemory * CVm::getMemory() { return pmMemory; }

bool CVm::step() {

	try {
		pcpCpu->exec();
	} catch (logic_error e) {

		MessageBox(NULL,e.what(),"G[",MB_OK);
		return false;

	}

	pvVideo->proc();

	return true;

}

CVm::~CVm() {

	delete pcpCpu;
	delete pmMemory;
	delete pvVideo;

}
